﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace RadControlsWinFormsApp1
{
    public partial class Form1 : Form
    {
        Size middlePanelSize = new Size(0, 300);
        Point startPoint;
        Point currentPoint;
        bool isMouseDown;

        public Form1()
        {
            InitializeComponent();

            this.splitPanel1.SizeInfo.SizeMode = Telerik.WinControls.UI.Docking.SplitPanelSizeMode.Absolute;

            this.splitPanel3.SizeInfo.SizeMode = Telerik.WinControls.UI.Docking.SplitPanelSizeMode.Absolute;
            this.splitPanel3.SizeInfo.AbsoluteSize = middlePanelSize;
            this.splitPanel3.SizeInfo.MaximumSize = middlePanelSize;
            this.splitPanel3.SizeInfo.MinimumSize = middlePanelSize;

            this.splitPanel3.MouseDown += new MouseEventHandler(splitPanel3_MouseDown);
            this.splitPanel3.MouseUp += new MouseEventHandler(splitPanel3_MouseUp);
        }

        void splitPanel3_MouseUp(object sender, MouseEventArgs e)
        {
            if (isMouseDown)
            {
                currentPoint = this.splitPanel3.ElementTree.Control.PointToScreen(e.Location);
                if (startPoint.Y > currentPoint.Y)
                {
                    if (startPoint.Y - currentPoint.Y > this.splitPanel1.SizeInfo.AbsoluteSize.Height)
                    {
                        this.splitPanel1.SizeInfo.AbsoluteSize = new Size(0, 10);
                    }
                    else
                    {
                        this.splitPanel1.SizeInfo.AbsoluteSize = new Size(0, this.splitPanel1.SizeInfo.AbsoluteSize.Height - startPoint.Y + currentPoint.Y);
                    }
                }
                else
                {
                    if (currentPoint.Y - startPoint.Y > this.splitPanel4.Size.Height)
                    {
                        this.splitPanel1.SizeInfo.AbsoluteSize = new Size(0, this.radSplitContainer1.Size.Height - middlePanelSize.Height - 40);
                    }
                    else
                    {
                        if (this.splitPanel1.SizeInfo.AbsoluteSize.Height < this.radSplitContainer1.Size.Height - middlePanelSize.Height - 40)
                        {
                            this.splitPanel1.SizeInfo.AbsoluteSize = new Size(0, this.splitPanel1.SizeInfo.AbsoluteSize.Height + currentPoint.Y - startPoint.Y);
                        }
                    }
                }
                isMouseDown = false;
            }
        }

        void splitPanel3_MouseDown(object sender, MouseEventArgs e)
        {
            startPoint = this.splitPanel3.ElementTree.Control.PointToScreen(e.Location);
            isMouseDown = true;
        }
    }
}
